;NSIS Modern User Interface
;Basic Example Script
;Written by Joost Verburg

;--------------------------------
;Include Modern UI

!include "MUI2.nsh"
!include "FontReg.nsh"
!include "FontName.nsh"

;--------------------------------
;General

  ;Name and file
  Name "Nat"
  OutFile "Nat installer.exe"

  ;Default installation folder
  InstallDir "$PROGRAMFILES\Nat"
  
  ;Get installation folder from registry if available
  InstallDirRegKey HKCU "Software\Nat" ""

  ;Request application privileges for Windows Vista
  RequestExecutionLevel user

;--------------------------------
;Interface Settings

  !define MUI_ABORTWARNING

;--------------------------------
;Pages

  !insertmacro MUI_PAGE_LICENSE "..\..\licence.txt"
  !insertmacro MUI_PAGE_COMPONENTS
  !insertmacro MUI_PAGE_DIRECTORY
  !insertmacro MUI_PAGE_INSTFILES
  
  !insertmacro MUI_UNPAGE_CONFIRM
  !insertmacro MUI_UNPAGE_INSTFILES
  
;--------------------------------
;Languages
 
  !insertmacro MUI_LANGUAGE "French"

;--------------------------------
;Installer Sections

Section "Nat" SecMain

  SetOutPath "$INSTDIR\aide"
  File /r /x *.svn "..\..\aide\*.*" 
    
  SetOutPath "$INSTDIR\configurations"	
  File "..\..\configurations\linux.cfg"
  File "..\..\configurations\unicode.cfg"
  File "..\..\configurations\windows-tbfr2007-2.cfg"
  File "..\..\configurations\windows-tbfr2007.cfg"
  
  SetOutPath "$INSTDIR"
  File /r /x *.svn "..\..\*.class"
  File /r /x *.svn "..\..\*.jar"
  File /r /x *.svn "..\..\*.png"
  
  SetOutPath "$INSTDIR\writer2latex"
  File /r "..\..\writer2latex\*.xml"
  
  SetOutPath "$INSTDIR\config"
  File /r "..\..\config\*.xml"
  
  SetOutPath "$INSTDIR\xsl"
  File /r /x *.svn "..\..\xsl\*.*" 

  SetOutPath "$INSTDIR\tmp"   
  File "..\..\licence.txt"
  
  SetOutPath "$INSTDIR\documents"
  File /r /x *.svn "..\..\documents\*.*"
  
  SetOutPath "$INSTDIR"   
  File "..\..\nat-launch-windows.bat"
  File "..\..\licence.txt"
  File "..\..\nat.exe"
  File "..\..\nat-gui.conf-initial"
  ;File "/oname=nat-gui.conf" "..\..\nat-gui.conf-initial"
  
  ;Store installation folder
  WriteRegStr HKCU "Software\Nat" "" $INSTDIR
  
  ;Create uninstaller
  WriteUninstaller "$INSTDIR\Uninstall.exe"

  CreateDirectory "$SMPROGRAMS\NAT"
  CreateShortCut "$SMPROGRAMS\NAT\NAT.lnk" "$INSTDIR\nat.exe"
  CreateShortCut "$SMPROGRAMS\NAT\NAT pour gros documents (avec console).lnk" "$INSTDIR\nat-launch-windows.bat"
  CreateShortCut "$SMPROGRAMS\NAT\Supprimer NAT.lnk" "$INSTDIR\Uninstall.exe"
  
SectionEnd

Section "Configuration pour DBT 10.7" SecDBT
  SetOutPath "$INSTDIR\configurations"	
  File "/oname=windows-dbt107.cfg" "..\..\configurations\windows-dbt107.cfg.initial"
  
  ReadRegStr $R1 HKLM "Software\Duxbury Systems, Inc." "LatestDBT"
  StrCmp $R1 "" nondetecte detecte
  nondetecte:
  MessageBox MB_OK "DBT 10.7 ou suprieur non dtect sur votre systme.$\nLa configuration sera installe mais vous devrez prciser o est DBT dans les options d'interface."
  StrCpy $R1 "Entrez ici le chemin d'accs  DBT 10.7 ou suprieur."
  Goto finDBT
  detecte:
  DetailPrint "DBT dtect ici : $R1"
  finDBT:
  ;mise  jour de la conf dbt avec le chemin de dbt
  FileOpen $4 "windows-dbt107.cfg" a
  FileSeek $4 0 END
  FileWrite $4 "$\r$\n" ; we write a new line
  FileWrite $4 "ui-editor-external="
  FileWrite $4 "$R1"
  FileWrite $4 "$\r$\n" ; we write an extra line
  FileClose $4 ; and close the file
SectionEnd

Section "Polices braille" SecPolice
  StrCpy $FONT_DIR $FONTS
 
  !insertmacro InstallTTFFont '..\fonts\BrailleAntoine.ttf'
  !insertmacro InstallTTFFont '..\fonts\braille_tbfr2007_b.ttf'
  
  SendMessage ${HWND_BROADCAST} ${WM_FONTCHANGE} 0 0 /TIMEOUT=5000
SectionEnd

!define MT4_REG_DIR_CONFIG "Software\Design Science\DSMT4\Config"
!define MT5_REG_DIR_CONFIG "Software\Design Science\DSMT5\Config"
!define MT6_REG_DIR_CONFIG "Software\Design Science\DSMT6\Config"
!define REG_KEY_TRANSLATORDIR "TranslatorDir"

!define MT4_REG_DIR_DIRECTORIES "Software\Design Science\DSMT4\Directories"
!define MT5_REG_DIR_DIRECTORIES "Software\Design Science\DSMT5\Directories"
!define MT6_REG_DIR_DIRECTORIES "Software\Design Science\DSMT6\Directories"
!define REG_KEY_PROGDIR "ProgDir"

Function Installezy
;MessageBox MB_OK "installation dans $R0"
SetOutPath "$R0"
File "mathtype\MathML (BraMaNet2).tdl"
FunctionEnd

Section "Convertisseur pour MathType" SecMathType
; mathtype 4

ReadRegStr $R0 HKLM "${MT4_REG_DIR_CONFIG}" "${REG_KEY_TRANSLATORDIR}"
StrCmp $R0 "" mt4_bis
DetailPrint "MathType 4 dtect sur votre systme."
Call Installezy
Goto mt5

mt4_bis:
ReadRegStr $R0 HKLM "${MT4_REG_DIR_DIRECTORIES}" "${REG_KEY_PROGDIR}"
StrCmp $R0 "" mt5
StrCpy $R0 "$R0\Translators"
DetailPrint "MathType 4 dtect sur votre systme."
Call Installezy

; mathtype 5
mt5:
ReadRegStr $R0 HKLM "${MT5_REG_DIR_CONFIG}" "${REG_KEY_TRANSLATORDIR}"
StrCmp $R0 "" mt5_bis
DetailPrint "MathType 5 dtect sur votre systme."
Call Installezy
Goto mt6

mt5_bis:
ReadRegStr $R0 HKLM "${MT5_REG_DIR_DIRECTORIES}" "${REG_KEY_PROGDIR}"
StrCmp $R0 "" mt6
DetailPrint "MathType 5 dtect sur votre systme."
StrCpy $R0 "$R0\Translators"
Call Installezy

; mathtype 6
mt6:
ReadRegStr $R0 HKLM "${MT6_REG_DIR_CONFIG}" "${REG_KEY_TRANSLATORDIR}"
StrCmp $R0 "" mt6_bis
DetailPrint "MathType 6 dtect sur votre systme."
Call Installezy
Goto done

mt6_bis:
ReadRegStr $R0 HKLM "${MT6_REG_DIR_DIRECTORIES}" "${REG_KEY_PROGDIR}"
StrCmp $R0 "" done
DetailPrint "MathType 6 dtect sur votre systme."
StrCpy $R0 "$R0\Translators"
Call Installezy

done:

SectionEnd
Section "Raccourcis sur le bureau" SecRaccourcis

 SetOutPath "$INSTDIR"
 CreateShortCut $DESKTOP\NAT.lnk $INSTDIR\nat.exe   
       
SectionEnd

;--------------------------------
;Descriptions

  ;Language strings
  LangString DESC_SecMain ${LANG_FRENCH} "Programme principal"
  LangString DESC_SecDBT ${LANG_FRENCH} "Configuration spciale pour export vers DBT 10.7. Ne fonctionnera pas si DBT 10.7 n'est pas install."
  LangString DESC_SecPolice ${LANG_FRENCH} "Police LouisLouis (Braille) pour les tables CBFr1252, DuxCBFr1252 et UTF8 ;  Police Braille INSHEA ralise par Marc Ollier (INSHEA) pour la nouvelle table tbfr2007."
  LangString DESC_SecMathType ${LANG_FRENCH} "Convertisseurs vers le MathML pour MathType"
  LangString DESC_SecRaccourcis ${LANG_FRENCH} "Raccourci sur le Bureau"
  

  ;Assign language strings to sections
  !insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
  !insertmacro MUI_DESCRIPTION_TEXT ${SecMain} $(DESC_SecMain)
  !insertmacro MUI_DESCRIPTION_TEXT ${SecDBT} $(DESC_SecDBT)
  !insertmacro MUI_DESCRIPTION_TEXT ${SecPolice} $(DESC_SecPolice)
  !insertmacro MUI_DESCRIPTION_TEXT ${SecRaccourcis} $(DESC_SecRaccourcis)
  !insertmacro MUI_DESCRIPTION_TEXT ${SecMathType} $(DESC_SecMathType)
  !insertmacro MUI_FUNCTION_DESCRIPTION_END

;--------------------------------
;Uninstaller Section

Section "Uninstall"

  RMDir /r "$INSTDIR\aide"
  RMDir /r "$INSTDIR\gestionnaires"
  RMDir /r "$INSTDIR\joptsimple"
  RMDir /r "$INSTDIR\nat"
  RMDir /r "$INSTDIR\outils"
  RMDir /r "$INSTDIR\config"
  RMDir /r "$INSTDIR\formula"
  RMDir /r "$INSTDIR\jaxe"
  RMDir /r "$INSTDIR\ui"
  RMDir /r "$INSTDIR\lib"
  RMDir /r "$INSTDIR\tmp"
  RMDir /r "$INSTDIR\writer2latex"
  RMDir /r "$INSTDIR\xsl"
  
  Delete "$INSTDIR\tmp*.*"
  Delete "$INSTDIR\nat-launch-windows.bat"
  Delete "$INSTDIR\nat.exe"
  Delete "$INSTDIR\nat-gui.conf-initial"
  Delete "$INSTDIR\licence.txt"
  
  Delete "$DESKTOP\NAT.lnk"
  
  Delete "$INSTDIR\Uninstall.exe"  
  RMDir /r $SMPROGRAMS\NAT
   
  DeleteRegKey /ifempty HKCU "Software\Nat"

SectionEnd
