/*
 * NAT - An universal Translator
 * Copyright (C) 2005 Bruno Mascret, 
 * Contact: bmascret@free.fr
 * 
 * Based on v2Math
 * Copyright (C) Rene Heuer,
 * http://www.exmpl.de/projects/mathml/math.html
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
package formula;


import java.awt.*;
import java.io.PrintWriter;
import java.io.StringWriter;
import javax.swing.*;
import formula.display.*;
import formula.define.*; // Pack mit display extern definierten Objekten

/**
Demonstration der extern definierten Objekte.
Copyright (C) 2006, Rene Heuer, Salingtwiete 4g. (D)20535 Hamburg
eMail: heuer@exmpl.de
Dieses Programm ist freie Software. Sie können es unter den Bedingungen der
GNU General Public License, wie von der Free Software Foundation veröffentlicht,
weitergeben und/oder modifizieren, entweder gemäß Version 2 der Lizenz oder
(nach Ihrer Option) jeder späteren Version. 
Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, daß es Ihnen von
Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite
Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN BESTIMMTEN ZWECK.
Details finden Sie in der GNU General Public License. 
Sie sollten ein Exemplar der GNU General Public License zusammen mit diesem
Programm erhalten haben. Falls nicht, schreiben Sie an die 
Free Software Foundation, Inc.,
59 Temple Place, 
Suite 330, 
Boston, MA 02111-1307, 
USA.
*/
public class DefDemo {

 /**
  * Main function for DefDemo
 * @param args command line params
 */
static public void main( String[] args) {
 JFrame frame = new JFrame();
 MathPanel panel = new MathPanel( null); 

  frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
  frame.setTitle( "Test-Frame des Mahtematik-Displays");
  frame.getContentPane().add( panel, "Center");
  frame.setSize( 1000, 700);
  frame.setVisible(true);

 Graphics2D g2d = (Graphics2D)panel.getGraphics();

  g2d.setFont( new Font( "serif", Font.PLAIN, 80));
  g2d.setRenderingHint( RenderingHints.KEY_ANTIALIASING,
                        RenderingHints.VALUE_ANTIALIAS_ON);

  DispObject.setDefaultColor( g2d.getColor());
  DispObject.setDefaultFont( g2d.getFont());
  DispObject.setDefaultRenderContext( g2d.getFontRenderContext());
  DispObject.setDefaultSpacing();

 DispRow base     = new DispRow( new DispObject[] {new DispString( "b")});
 DispRow exponent = new DispRow( new DispObject[] {new DispString( "e")});
 Exp exp = new Exp( base, exponent);

  panel.setObject(exp); // obj; // Objekt an Panel binden
  panel.repaint();    // Panel (mit Objekt) anzeigen.

  // textuelle Ausgabe vorbereiten und starten
  DispObject.term = new StringWriter();               // String bekommt Ausgaben
  DispObject.out = new PrintWriter( DispObject.term); // Print-Methoden bereitstellen
  DispObject.print( 0, exp);                          // Ausgabe erzeugen
 String term = DispObject.term.toString();            // Ausgabe lesen
  System.out.println( term);                          // aufgebauten String anzeigen
  DispObject.term = new StringWriter();               // bereit für neue Ausgaben
  DispObject.out = new PrintWriter( DispObject.term); // mit Print-Methoden
 }
}
