/*
 * NAT - An universal Translator
 * Copyright (C) 2005 Bruno Mascret, 
 * Contact: bmascret@free.fr
 * 
 * Based on v2Math
 * Copyright (C) Rene Heuer,
 * http://www.exmpl.de/projects/mathml/math.html
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
package formula;


import java.awt.*;
import javax.swing.*;
import formula.display.*;

/**
Einfaches Panel zur Bereitstellung eines grafischen Kontextes.
Copyright (C) 2006, Rene Heuer, Salingtwiete 4g. (D)20535 Hamburg
eMail: heuer@exmpl.de
Dieses Programm ist freie Software. Sie können es unter den Bedingungen der
GNU General Public License, wie von der Free Software Foundation veröffentlicht,
weitergeben und/oder modifizieren, entweder gemäß Version 2 der Lizenz oder
(nach Ihrer Option) jeder späteren Version. 
Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, daß es Ihnen von
Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite
Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN BESTIMMTEN ZWECK.
Details finden Sie in der GNU General Public License. 
Sie sollten ein Exemplar der GNU General Public License zusammen mit diesem
Programm erhalten haben. Falls nicht, schreiben Sie an die 
Free Software Foundation, Inc.,
59 Temple Place, 
Suite 330, 
Boston, MA 02111-1307, 
USA.
*/
public class MathPanel extends JComponent 
{
	/** for serialization (not used) */
	private static final long serialVersionUID = 123; // sonst warnt eclipse
	/** the DispObject to paint */
	private DispObject object;

	/**
	* Creator ohne Parameter. Kann gerfärlich sein...
	*/
	public MathPanel() {}//setSize(new Dimension(100,100));}
	/**
	 *Creator mit Bindung des anzuzeigenden Objekts.
	 * @param object das anzuzeigende Objekt.
	 */
	public MathPanel( DispObject object) {this.object = object;}
	 
	/**
	 *Überschreiben der ursprünglichen Methode zur eigenen Darstellung.
	 *@param g1 einfacher grafischer Kontext.
	 */
	public void paintComponent( Graphics g1)
	{
		super.paintComponent( g1);
		if (object != null)
		{
			DispObject.paintAt( object, 
				              0, 
				              (Graphics2D)g1, 
				              (this.getWidth() -object.bnd.getWidth())  / 2.0, 
				              (this.getHeight()-object.bnd.getHeight()) / 2.0);
		}
	}
	/**
	 * Set the value for {@link #object} 
	 * @param obj the DispObject instance for {@link #object}
	 */
	public void setObject(DispObject obj) {object=obj;}
}
