package gestionnaires;

import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.io.File;
import java.util.Collections;
import java.util.Vector;

import javax.swing.JComboBox;

/**
 * Gestionnaire mettant à jour les tables brailles dans les combobox
 * @author bruno
 *
 */
public class GestionnaireMajTabBraille implements WindowListener
{
	/** liste des tables brailles */
	private JComboBox comboTables;
	/** liste des tables braille d'embossage */
	private JComboBox comboTablesImp;
	/**
	 * Constructeur
	 * @param combo1 pointe sur la liste des tables brailles
	 * @param combo2 pointe sur la liste des tables brailles d'impression
	 */
	public GestionnaireMajTabBraille (JComboBox combo1, JComboBox combo2)
	{
		comboTables = combo1;
		comboTablesImp = combo2;
	}
	
	/**
	 * Implémentation; ne fait rien
	 * @see java.awt.event.WindowListener#windowActivated(java.awt.event.WindowEvent)
	 */
	public void windowActivated(WindowEvent arg0) {}

	/** 
	 * Implémentation; mets à jour les combobox des tables
	 * @see java.awt.event.WindowListener#windowClosed(java.awt.event.WindowEvent)
	 */
	public void windowClosed(WindowEvent arg0)
	{
		File repertoire =new File("./xsl/tablesBraille");
		File[] listTables = repertoire.listFiles();
	    //String table = "";
	    
		int taille = listTables.length;
		Vector<String> namesList = new Vector<String>(taille);
		String selection1 = comboTables.getSelectedItem().toString();
		String selection2 = comboTablesImp.getSelectedItem().toString();
		
		for(int i=0;i<taille;i++)
	    {
	    	String nomTable = listTables[i].getName() ;
	    	if (nomTable.endsWith(".ent") && !nomTable.equals("Brltab.ent"))
	    	{
	    		namesList.add(nomTable.substring(0,nomTable.length()-4));
	    	}
	    }
		
		Collections.sort(namesList);
		
		comboTables.removeAllItems();
		comboTablesImp.removeAllItems();
		taille = namesList.size();
		
		for(int i=0;i<taille;i++)
	    {
	    	comboTables.addItem(namesList.get(i));
	    	comboTablesImp.addItem(namesList.get(i));
	    }
	    
	    comboTables.setSelectedItem(selection1);
	    comboTablesImp.setSelectedItem(selection2);
	}
	/**
	 * Implémentation; ne fait rien
	 * @see java.awt.event.WindowListener#windowClosing(java.awt.event.WindowEvent)
	 */
	public void windowClosing(WindowEvent arg0) {}
	/**
	 * Implémentation; ne fait rien
	 * @see java.awt.event.WindowListener#windowDeactivated(java.awt.event.WindowEvent)
	 */
	public void windowDeactivated(WindowEvent arg0) {}
	/**
	 * Implémentation; ne fait rien
	 * @see java.awt.event.WindowListener#windowDeiconified(java.awt.event.WindowEvent)
	 */
	public void windowDeiconified(WindowEvent arg0) {}
	/**
	 * Implémentation; ne fait rien
	 * @see java.awt.event.WindowListener#windowIconified(java.awt.event.WindowEvent)
	 */
	public void windowIconified(WindowEvent arg0){}
	/**
	 * Implémentation; ne fait rien
	 * @see java.awt.event.WindowListener#windowOpened(java.awt.event.WindowEvent)
	 */
	public void windowOpened(WindowEvent arg0) {}
}
