package nat.convertisseur;

import gestionnaires.GestionnaireErreur;
import nat.convertisseur.Convertisseur;
import outils.FileToolKit;
/**
 * <p>La classe <code>ConvertisseurSans</code> se contente de recopier le fichier d'entrée dans le fichier de sortie.
 * Elle ne réalise pas de conversion.</p>
 * @author  Bruno Mascret
 */
public class ConvertisseurSans extends Convertisseur
{

	/**
	 * Constructeur
	 * @param fs adresse du fichier source
	 * @param tempXML adresse du fichier cible
	 */
	public ConvertisseurSans(String fs, String tempXML){super(fs,tempXML);}

	/**
	 * Convertit le fichier {@link Convertisseur#source}
	 * @see nat.convertisseur.Convertisseur#convertir(gestionnaires.GestionnaireErreur)
	 */
	@Override
	public boolean convertir(GestionnaireErreur gest)
	{
		return FileToolKit.copyFile(source, cible);
	}

}
