package nat.presentateur;

/*import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.nio.MappedByteBuffer;
import java.nio.channels.FileChannel;
import java.nio.charset.Charset;
import java.nio.charset.CharsetDecoder;
import java.nio.charset.CharsetEncoder;
import java.nio.charset.IllegalCharsetNameException;
import java.nio.charset.UnsupportedCharsetException;*/

import outils.FileToolKit;

import nat.Nat;
import gestionnaires.GestionnaireErreur;
/**
 * Effectue un rendu basique du fichier transcrit
 * <p>Se contente d'encoder correctement le fichier de sortie</p>
 * @author bruno
 *
 */
public class PresentateurSans extends Presentateur
{
	/** encodage du fichier de sortie */
	private String charset;
	/**
	 * Constructeur
	 * @param gest une instance de {@link GestionnaireErreur}
	 * @param source L'adresse de la sortie
	 * @param sortie l'adresse du fichier transcrit à présenter
	 * @param charset encodage du fichier de sortie
	 * @param tab la table braille de sortie
	 */
	public PresentateurSans(GestionnaireErreur gest, String charset, String source,String sortie, String tab)
	{
		super(gest,source,sortie, tab);
		//this.gest = gest;
		this.charset = charset;
	}
	/**
	 * Encode le fichier d'entrée avec la table braille et l'encodage de sortie
	 *
	 */
	protected void encode()
	{
		//encodage dans le charset et la table braille désirés
		FileToolKit.convertBrailleFile(source, sortie,"brailleUTF8",tableBraille,"UTF-8", charset, gest);
	}
	/**
	 * Rédéfinition de {@link Presentateur#presenter()}
	 * <p>Se contente pour produire le rendu d'encoder le fichier source avec l'encodage du fichier de sortie</p> 
	 */
	public boolean presenter()
	{
		tempsExecution = System.currentTimeMillis();
		gest.afficheMessage("\nDébut de la mise en forme du document ... ok\n",Nat.LOG_SILENCIEUX);
		encode();
		gest.afficheMessage("ok\n** mise en forme ...",Nat.LOG_NORMAL);
		tempsExecution = System.currentTimeMillis() - tempsExecution;
		return true;
	}
}