package nat.transcodeur;

import gestionnaires.GestionnaireErreur;
import nat.transcodeur.Transcodeur;
import outils.FileToolKit;
/**
 * <p>La classe <code>TranscodeurSans</code> se contente de recopier le fichier d'entrée dans le fichier de sortie.
 * Elle ne réalise pas de transcription.</p>
 * @author  Bruno Mascret
 */
public class TranscodeurSans extends Transcodeur {

	/**
	 * Constructeur
	 * @param e fichier entrée
	 * @param s fichier sortie
	 * @param se encodage entrée
	 * @param g instance de GestionnaireErreur
	 */
	public TranscodeurSans(String e, String s, String se, GestionnaireErreur g)
	{
		super(e, s, se, g);
	}

	/**
	 * Copy le fichier d'entrée dans le fichier de sortie
	 * @see nat.transcodeur.Transcodeur#transcrire(gestionnaires.GestionnaireErreur)
	 */
	@Override
	public boolean transcrire(GestionnaireErreur gestErreur) {
		return FileToolKit.copyFile(entree, cible);
	}

}
