package ui;

import gestionnaires.Afficheur;

import javax.swing.JTextArea;

/**
 * Afficheur de message des Gestionnaires d'erreur en mode Swing (graphique)
 * <p>Hérite de JTextArea comme conteneur de base</p>
 * @author bruno
 *
 */
public class AfficheurJTASwing extends JTextArea implements Afficheur
{

	/** defaut serial version uid, non utilisé */
	private static final long serialVersionUID = 1L;
	/** 
	 * Constructeur
	 * @param i nombre de lignes du JTextArea
	 * @param j nombre de colonnes du JTextArea
	 */
	public AfficheurJTASwing(int i, int j) {super(i,j);}
	/**
	 * Redéfinition de gestionnaires.Afficheur#afficheMessage(java.lang.String)
	 * <p>Affiche le message <code>message</code> à la suite du texte déjà présent
	 * dans l'instance</p>
	 * @see gestionnaires.Afficheur#afficheMessage(java.lang.String)
	 */
	public void afficheMessage(String message)
	{
		setText(getText() + message);
		setCaretPosition(getText().length());
	   // paintImmediately(new Rectangle(0,0,getWidth(),getHeight()));
	}

}
