<?xml version='1.0' encoding="UTF-8" ?>
<!--
 * NAT - An universal Translator
 * Copyright (C) 2005 Bruno Mascret
 * Contact: bmascret@free.fr
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-->

<!-- version: 1.3-b3 -->

<!DOCTYPE xsl:stylesheet SYSTEM "mmlents/windob.dtd">


<xsl:stylesheet version="2.0"
xmlns:xsl='http://www.w3.org/1999/XSL/Transform' 
xmlns:saxon='http://icl.com/saxon'
xmlns:xs='http://www.w3.org/2001/XMLSchema'
xmlns:fn='http://www.w3.org/2005/xpath-functions'
xmlns:fo='http://www.w3.org/1999/XSL/Format'
xmlns:m='http://www.w3.org/1998/Math/MathML'
xmlns:lit='espacelit'
xmlns:doc='espaceDoc'>

<xsl:output method="xml" encoding="UTF-8" indent="yes"/>

<xsl:include href="fr-g2.xsl"/>

<xsl:template match="lit">
	<!--<xsl:text>debLit</xsl:text>-->
	<xsl:apply-templates select="@*|*|text()|processing-instruction()" />
	<!--<xsl:text>FinLit</xsl:text>-->
</xsl:template>

<xsl:template match="ponctuation[@type='puce']">
	<xsl:text>&pt36;&pt36;</xsl:text>	
</xsl:template>

<xsl:template match="ponctuation[@type='ordre']">
	<xsl:text>&pt6;</xsl:text>
	<xsl:call-template name="bijection">
		<xsl:with-param name="mot" select="@num" />
	</xsl:call-template>
	<xsl:text>&pt36;&pt36;</xsl:text>	
</xsl:template>

<xsl:template match="ponctuation">
	<xsl:choose>
		<!-- chat braille -->
		<xsl:when test=".=')' and (string(preceding::*[1])='B-')" />
		<!-- pts de suspension; -->
	     <xsl:when test=".='...' or .='…' or .='&mldr;' or .='&vellip;' or .='&hellip;' or .='&dtdot;' or .='&ldots;' or .='&ctdot;' or .='&utdot;'">
	       <xsl:text>&pt256;&pt256;&pt256;</xsl:text>
	     </xsl:when>
		<xsl:when test='string(.)="&apos;"'>
			<xsl:text>&pt3;</xsl:text>
		</xsl:when>
		<xsl:when test=".='['">
			<xsl:text>&pt45;&pt236;</xsl:text>
		</xsl:when>
		<xsl:when test=".=']'">
			<xsl:text>&pt356;&pt12;</xsl:text>
		</xsl:when>
		<xsl:when test=".='{'">
			<xsl:text>&pt6;&pt6;&pt236;</xsl:text>
		</xsl:when>
		<xsl:when test=".='}'">
			<xsl:text>&pt356;&pt3;&pt3;</xsl:text>
		</xsl:when>
		<xsl:when test=".='*'">
			 <xsl:text>&pt5;&pt35;</xsl:text>
		</xsl:when>
		<xsl:when test=".='-'">
			<!-- est-ce le signe mathématique - ou un tiret? -->
			<xsl:choose>
				<!-- il y a des numériques avant et/ou après, ou il y a d'autres opérateurs mathématiques (+ ou = ) dans la phrase-->
				<xsl:when test="(number(translate(string(preceding-sibling::*[1]),',0','.1')) or number(translate(string(following-sibling::*[1]),',0','.1'))) or contains(translate(string(..),'+','='),'=')"><!-- conversion des , en . et des 0 en 1 car number(0) et number(NNN,NNN) renvoie faux -->
					<xsl:text>&pt6;</xsl:text>
				</xsl:when>
				<xsl:otherwise><!-- test=".=../child::*[1]">-->
					<xsl:text>&pt36;</xsl:text>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:text>&pt36;</xsl:text>
		</xsl:when>
		<xsl:otherwise>
			<!-- utilisation d'une variable pour éviter les pb du translate et des '" -->
			<xsl:variable name="v">
				<xsl:text>&pt2;&pt23;&pt25;&pt256;&pt26;&pt235;&pt2356;&pt2356;&pt2356;&pt2356;&pt2356;&pt2356;&pt2356;&pt3;&pt3;&pt3;&pt3;&pt236;&pt356;&pt235;&pt26;</xsl:text>
			</xsl:variable>
			<xsl:value-of select="translate(string(.),',;:.?!&quot;«»“”‘’&lsquo;&rsquo;&acute;&prime;()¡¿
',string($v))"/>
		</xsl:otherwise>
	</xsl:choose><!--
	<xsl:if test="not (local-name(following::*[1])='phrase') and not(contains('([{«“‘&lsquo;',.)) and not(local-name(following::*[1])='ponctuation')"> RAF:à améliorer pour les guillemets et apos ouvrantssimples 
		<xsl:text> </xsl:text>
	</xsl:if>-->
	<xsl:if test="not (local-name(following::*[1])='phrase') and not(contains('¡¿
([{«“‘&lsquo;',string(.)))"><!-- RAF:à améliorer pour apos ouvrantssimples -->
		<xsl:call-template name="espace"/>
	</xsl:if>
</xsl:template>
</xsl:stylesheet>